module IntOp{
	role(endemic){
	}

}

slice IntOp {
	init{
		OpTable.otTable.get("SubTable").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR, 
			getCurrentClass().getDeclaredMethod("SubInt",ArrayList.class),"Integer");
		OpTable.otTable.get("SumTable").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("SumInt",ArrayList.class),"Integer");
		OpTable.otTable.get("MulTable").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("MulIntInt",ArrayList.class),"Integer");
		OpTable.otTable.get("GreaterEq").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("GreaterEqIntInt",ArrayList.class),"Boolean");
		OpTable.otTable.get("LessEq").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("LessEqIntInt",ArrayList.class),"Boolean");
		OpTable.otTable.get("Greater").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("GreaterIntInt",ArrayList.class),"Boolean");
		OpTable.otTable.get("Less").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("LessIntInt",ArrayList.class),"Boolean");
		OpTable.otTable.get("Equal").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("EqIntInt",ArrayList.class),"Boolean");
		OpTable.otTable.get("NotEqual").addTypesComparation("Integer"+OperationTable.TYPE_SEPARATOR+"Integer"+OperationTable.TYPE_SEPARATOR,
			getCurrentClass().getDeclaredMethod("NotEqIntInt",ArrayList.class),"Boolean");
	}
	decl{
		import java.util.*;
		import operationSupport.*;
		String SubInt(ArrayList<String> values){
			if(values.size()<2){
				System.err.println("Sum int Not enough arguments");
				return "";
			}
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));
			return (i1-i2)+"";
		}
		String SumInt(ArrayList<String> values){
			if(values.size()<2){
				System.err.println("Sum int Not enough arguments");
				return "";
			}
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));
			return (i1+i2)+"";
		}
		String SumIntStr(ArrayList<String> values){
			if(values.size()<2){
				System.err.println("Sum int string Not enough arguments");
				return "";
			}
			Integer i1 = new Integer(values.get(0));
			return (i1+values.get(1).length())+"";
		}
		String SumStrInt(ArrayList<String> values){
			if(values.size()<2){
				System.err.println("Sum string int Not enough arguments");
				return "";
			}
			Integer i1 = new Integer(values.get(1));
			return (i1+values.get(0).length())+"";
		}

		String MulIntInt(ArrayList<String> values){
			if(values.size()<2){
				System.err.println("Mul int int Not enough arguments");
				return "";
			}
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));
			return (i1*i2)+"";
		}
		String GreaterEqIntInt(ArrayList<String> values){
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));

			if(i1>=i2){
				return 1+"";
			}else{
				return 0+"";
			}	
		}
		String LessEqIntInt(ArrayList<String> values){
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));
			if(i1<=i2){
				return 1+"";
			}else{
				return 0+"";
			}		}
		String GreaterIntInt(ArrayList<String> values){
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));
			if(i1>i2){
				return 1+"";
			}else{
				return 0+"";
			}		}
		String LessIntInt(ArrayList<String> values){
			Integer i1 = new Integer(values.get(0));
			Integer i2 = new Integer(values.get(1));
			if(i1<i2){
				return 1+"";
			}else{
				return 0+"";
			}		
		}
		String EqIntInt(ArrayList<String> values){
			int i1 = new Integer(values.get(0));
			int i2 = new Integer(values.get(1));
			if(i1==i2){
				return 1+"";
			}else{
				return 0+"";
			}		
		}
		String NotEqIntInt(ArrayList<String> values){
			int i1 = new Integer(values.get(0));
			int i2 = new Integer(values.get(1));
			if(i1!=i2){
				Logger.printDebug("i1 e i2 sono diversi "+i1+" "+i2);
				return 1+"";
			}else{
				Logger.printDebug("i1 e i2 sono uguali "+i1+" "+i2);
				return 0+"";
			}
		}

		void InitTable(){
		
		}

	
	}
	module IntOp with role endemic

}
